/*
	ArchiveSMTP Milter v1.1.b1
	--------------------------
	Copyright (c) 2008, 2009, 2010 Dancing Fortune Software.
	All rights reserved.
	 
	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions
	are met:
	 
	1. Redistributions of source code must retain the above copyright
	notice, this list of conditions and the following disclaimer.
	 
	2. Redistributions in binary form must reproduce the above copyright
	notice, this list of conditions and the following disclaimer in the
	documentation and/or other materials provided with the distribution.
	 
	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
	ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
	LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
	CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
	POSSIBILITY OF SUCH DAMAGE.
 */

enum
{
	kActionStoreIn,			/* Store in a file action */
	kActionAddHeader,		/* Add a header to mail action */
	kActionPipe				/* Pipe mail to another program action */
};

enum
{
	kTokenNone,				/* No tokens, just plain text string */
	kTokenSender,			/* %SENDER%			- Sender name (usually a local username or null) */
	kTokenSenderUser,		/* %SENDER.USER%	- Sender username (usually same as sender) */
	kTokenSenderDomain,		/* %SENDER.DOMAIN%  - Sender domain name (usually null) */
	kTokenFrom,				/* %FROM%			- From address */
	kTokenFromUser,			/* %FROM.USER%		- From username */
	kTokenFromDomain,		/* %FROM.DOMAIN%	- From domain name */
	kTokenTo,				/* %TO%				- To address */
	kTokenToUser,			/* %TO.USER%		- To username */
	kTokenToDomain,			/* %TO.DOMAIN%		- To domain name */
	kTokenAllTo,			/* %ALLTO%			- Iteration through all To addresses */
	kTokenAllToUser,		/* %ALLTO.USER%		- Iteration through all To usernames */
	kTokenAllToDomain		/* %ALLTO.DOMAIN%	- Iteration through all To domains */
};

typedef struct Token_s Token;
struct Token_s
{
	int			field;		/* Field to sub for token */
	char		*preText;	/* String prepending token */
	Token		*next;		/* Next token (if any) */
};

typedef struct Action_s Action;
struct Action_s
{
	int			type;		/* The type of action (store, add header, pipe) */
	bool		allTo;		/* Set if action makes use if ALLTO token */
	toAddrList_t *addrItr;	/* Pointer to current TO iteration */
	int			pathLen;	/* String length of the path without tokens subbed */
	Token		*args;		/* List of arguments split by tokens to be subbed */
	Action		*next;		/* Pointer to the next action to take (if any) */
};
